
#ifndef PLS_SYSTEM_DETAILS_H
#define PLS_SYSTEM_DETAILS_H

#include <cstdint>

namespace pls {
    namespace internal {
        namespace base {
            /**
             * Collection of system details, e.g. hardware cache line size.
             *
             * PORTABILITY:
             * Currently sane default values for x86.
             */
            namespace system_details {
                /**
                 * Most processors have 64 byte cache lines
                 */
                constexpr std::uintptr_t CACHE_LINE_SIZE = 64;

                /**
                 * Choose one of the following ways to store thread specific data.
                 * Try to choose the fastest available on this processor/system.
                 */
//                #define PLS_THREAD_SPECIFIC_PTHREAD
                #define PLS_THREAD_SPECIFIC_COMPILER
            }
        }
    }
}

#endif //PLS_SYSTEM_DETAILS_H
