
#ifndef PLS_TTAS_SPIN_LOCK_H
#define PLS_TTAS_SPIN_LOCK_H

#include "tas_spin_lock.h"

#include <atomic>
#include <iostream>

#include "pls/internal/base/thread.h"

namespace pls {
    namespace internal {
        namespace base {
            /**
             * A simple set and test_and_set based spin lock implementation.
             *
             * PORTABILITY:
             * Current implementation is based on C++ 11 atomic_flag.
             */
            class ttas_spin_lock {
                std::atomic<int> flag_;
                unsigned int yield_at_tries_;


            public:
                ttas_spin_lock(): flag_{0}, yield_at_tries_{1024} {};
                ttas_spin_lock(const ttas_spin_lock& other): flag_{0}, yield_at_tries_{other.yield_at_tries_} {}

                void lock();
                bool try_lock();
                void unlock();
            };
        }
    }
}


#endif //PLS_TTAS_SPIN_LOCK_H
